# Workspaces Production Deployment

## Before Deployment

* Ensure all changes made to the test system during stakeholder testing have been added back into main. 
  * Verify all expected database migrations are present. Database changes are frequently made directly to the database
  during testing, ensure all changes have associated migrations 
* Create Release Notes
* Update <span style="color:cornflowerblue">dsoc-prod</span> Capo Properties
* Back up Production Database (If deploying in conjunction with AAT, the AAT procedure covers this step)
* Send 'Beginning Deployment' notification to <span style="color:cornflowerblue">ssa-announcements@nrao.edu</span>


## At Deployment

* Checkout the main branch.
* Run any needed schema migrations on the production database: <span style="color:cornflowerblue">
  docker compose -f docker-compose.local.yml --profile schema-prod up schema-prod
  </span>
* Tag the main branch for production deployment: 
  <span style="color:cornflowerblue">
  {version#}
  </span>
  * This tag is then automatically pushed up to the production server as part of the WS CI/CD pipeline.


## After Deployment
* Ensure production PEXes have been updated on the cluster after deployment to production. 
  * Check the build dates in the workspaces/sbin/ area.
  * If ingest changes were included in the release, ensure the ingest pex is copied over from the test environment
* Smoke test production
* Run a 'null' request, this will force the Capability Queue Manager to update and the Workflow Reacquire System to 
recover active workflow monitoring
* Send 'All Clear' notification to <span style="color:cornflowerblue">ssa-announcements@nrao.edu</span>
* Setup release in GitLab with relevant version tag and link release notes
* Release version in JIRA (i.e. Poke the Release Manager to do this)
